::----------------------------------------------------------------------------------------------------- 
:: Script:			:	PrinterDrivers.CMD 
:: Created by:			:	Wilco van Bragt (http://sbc.vanbragt.net) 
::
:: Changed 2010-02-05		:	Johan Eksberg (http://www.eksberg.se)
::
:: 
:: Other resources nedeed	:	SLEEP.EXE, ROBOCOPY.EXE (in %SOURCE% PATH)
::
:: INFO				:	Change <<FILSERVER>>\SHARE to fit your environment
:: INFO				:	Remove Stop/Start of Citrix Print Manager if only TS is in use
:: 
:: ---------------------------------------------------------------------------------------------------

:: Disable Logons 
CHANGE LOGON /DISABLE 

:: SET PATH
SET DRIVERPATH=\\<<FILSERVER>>\SHARE\Printerdriver\spool 
SET INFPATH\\<<FILSERVER>>\SHARE\Printerdriver\inf 
SET REGPATH\\<<FILSERVER>>\SHARE\Printerdriver\reg 
SET SOURCE\\<<FILSERVER>>\SHARE\Printerdriver\

:: Wait 30 second to get the printer spooler services started (or put the services on manual). 
%SOURCE%\SLEEP.EXE 30 

:: Stop Print Spooler and corresponding services
NET STOP "Citrix Print Manager Service" /yes 
NET STOP "Print Spooler" /yes 

:: Remove the printer registry keys 
%SOURCE%\REG.EXE DELETE "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Drivers" /FORCE 

::Remove all printer drivers from the spool directory 
DEL /S /Q /F %SYSTEMROOT%\system32\spool 

:: Import driverpackage registry keys 
%SYSTEMROOT%\REGEDIT.EXE /S "%REGPATH%\PrinterDrivers.REG" 
%SYSTEMROOT%\REGEDIT.EXE /S "%REGPATH%\monitors.REG"                                                                                        

:: Replicate the printerdrivers  
%SOURCE%\ROBOCOPY.EXE "%DRIVERPATH%" "%systemroot%\system32\spool" /MIR /R:1 /W:1 /NP                                 
XCOPY "%INFPATH%" "%systemroot%\INF" /E /C /I /Q /H /R /Y 

:: Start the print services (again)
NET START "Print Spooler"                                                                                                    

NET START "Citrix Print Manager Service" 

:: Enable Logons 
CHANGE LOGON /ENABLE 

:: End of script
GOTO :EOF
